
from PySteppables import *
import CompuCell
import sys
class MitosisTrackerSteppable(SteppableBasePy):    

    def __init__(self,_simulator,_frequency=1):
        SteppableBasePy.__init__(self,_simulator,_frequency)
    def start(self):
        
        self.cellField[50,50,0] = self.newCell(self.A) 
        for cell in self.cellList:
            cell.targetVolume=25
            cell.lambdaVolume=2.0  
            
            cellDict=self.getDictionaryAttribute(cell)
            cellDict["MitosisData"]=[[0,0]]
            
            
            
            
  
  
        
    def step(self,mcs):        
        for cell in self.cellList:
            cell.targetVolume += 0.1
            
        

    def finish(self):
        # Finish Function gets called after the last MCS
        pass
        
from PySteppables import *
from PySteppablesExamples import MitosisSteppableBase
import CompuCell
import sys

from PlayerPython import *
from math import *


class Mitosis(MitosisSteppableBase):
    def __init__(self,_simulator,_frequency=1):
        MitosisSteppableBase.__init__(self,_simulator, _frequency)
    
    def step(self,mcs):
        # print "INSIDE Mitosis"
        
        self.mcs=mcs
        
        cells_to_divide=[]
        for cell in self.cellList:
            if cell.volume>50:
                
                cells_to_divide.append(cell)
                
        self.numberOfCellsMitosis = len(cells_to_divide)
        
        for cell in cells_to_divide:
            # to change mitosis mode leave one of the below lines uncommented
            self.divideCellRandomOrientation(cell)
            # self.divideCellOrientationVectorBased(cell,1,0,0)                 # this is a valid option
            # self.divideCellAlongMajorAxis(cell)                               # this is a valid option
            # self.divideCellAlongMinorAxis(cell)   
            # this is a valid option
        if not mcs%100:
            try:                
                fileHandle,fullFileName=self.openFileInSimulationOutputDirectory("MITOSOS_DATA"+str(mcs)+'.dat',"w")
            except IOError:
                print "Could not open file ", "YOUR FILE NAME"," for writing. "                
                return
            
            for cell in self.cellList:
                cellDict=self.getDictionaryAttribute(cell)
                print cellDict
                
                print >> fileHandle,cellDict
                
            fileHandle.close()    
            
    def updateAttributes(self):
        parentCell=self.mitosisSteppable.parentCell
        childCell=self.mitosisSteppable.childCell
        
        
        
        parentCell.targetVolume = 25.0
        
        childCell.targetVolume = parentCell.targetVolume
        childCell.lambdaVolume = parentCell.lambdaVolume
        
        
        childCell.type = self.B
        
        parentCellDict=self.getDictionaryAttribute(parentCell)
        
        # parentCellDict["MitosisData"] == [list]
        
        parentCellDict["MitosisData"].append([self.mcs,childCell.id])
        
        childCellDict=self.getDictionaryAttribute(childCell)
        childCellDict["MitosisData"]=[[self.mcs,childCell.id]]   
       
      
     
    
   
  
  
    







